#ifndef __CANUSER_H__
#define __CANUSER_H__



/*******************************************************************************
 * the includes
 ******************************************************************************/
#include "mcu.h"
#include "uds.h"
#include "mfs_canmatrix-binutil.h"
/*******************************************************************************
* the defines
******************************************************************************/
#define CAN_DATA_BUFFER_SIZE (8u)

#define UDS_PHYS_RECV_MSG_ID (0x732)
#define UDS_FUNC_RECV_MSG_ID (0x7DF)
#define UDS_PHYS_RESP_MSG_ID (0x7B2)

 
 /*******************************************************************************
 * the typedefs
 ******************************************************************************/
 typedef struct
{
    uint32_t id;
    uint8_t  data[CAN_DATA_BUFFER_SIZE];
    uint8_t  len;
    uint16_t timeStamp;
    uint32_t hrTimeStamp;
} FlexCan_FrameStructureType;
 
 /*******************************************************************************
 * the globals
 ******************************************************************************/
 
 
 
 
 /*******************************************************************************
 * the functions
 ******************************************************************************/

void FlexCanBoot_Init(void);
bool FlexCanBoot_ReadoutMsg(FlexCan_FrameStructureType *pRxMsgObj);
int8_t FlexCanBoot_TxMessage(uint32_t msgId, const uint8_t* pData, uint8_t size);

void CANMsgTask(void);
void CAN_MsgUpdate(void);


#endif
