/*
 * Copyright (c) 2022, Shenzhen CVA Innovation CO.,LTD
 * All rights reserved.
 *
 * Shenzhen CVA Innovation CO.,LTD (CVA chip) is supplying this file for use
 * exclusively with CVA's microcontroller products. This file can be freely
 * distributed within development tools that are supporting such microcontroller
 * products.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * CVA SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 */

#ifndef _TOUCH_WIDGET_CONFIG_H_
#define _TOUCH_WIDGET_CONFIG_H_

/*! \brief Contains public interface to various functions related
 *         to the driver of TOUCH module
 */

/******************************************************************************
 * the includes
 *****************************************************************************/
#include <stdint.h>
#include "touch_drv.h"
#include "touch_config.h"
#include "touch_button.h"

/*! \addtogroup touch
 *  @{
 */

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************
 * the defines
 *****************************************************************************/
#define TOUCH_BUTTON_NUM            (1)
#define TOUCH_BUTTON0_ELEMENT_NUM   (1)

/******************************************************************************
 * the typedefs
 *****************************************************************************/

/******************************************************************************
 * the globals
 ******************************************************************************/
extern ButtonDrv_CfgType g_button_cfg;

/******************************************************************************
 * the function prototypes
 ******************************************************************************/

#ifdef __cplusplus
}
#endif /* extern "C" */

/*! @}*/

#endif

